
-- Fall-Winter Demo 2012
-- turtlesort.com
-- Kevin Sacro

function love.load() 

	game       = require 'lib.ext.transdirector'
	game.utf8  = require 'lib.utf8'
	game.timer = require 'lib.timer'
	game.font  = require 'lib.fontcache'
	game.text  = require 'lib.adv.textsystem'
	
	-- Some initial text setup
	game.font.setDefaultFont('fonts/PressStart2P/PressStart2P.ttf')
	game.text.init(game.font.get(16))
	
	-- These constants should be defined before scenes
	-- start being added.
	game.tilewidth  = 48
	game.tileheight = 48
	
	-- Define the scenes we will use in this game
	game.addScene(require 'scenes.mainmenu', 'mainmenu')
	game.addScene(require 'scenes.preprimary', 'preprimary')
	game.addScene(require 'scenes.primary',  'primary')
	game.addScene(require 'scenes.postprimary',  'postprimary')
	
	game.setCurrentScene('mainmenu')
	--game.setCurrentScene('primary')
	
end

function love.update(dt) 
	game.update(dt)
	game.text.update(dt)  -- Text scrolling
	game.timer.update(dt) -- Timed tasks
end

function love.draw() 
	game.draw()
	game.text.draw()
	
	-- Debugging:
	-- love.graphics.line(love.graphics.getWidth()/2,0,love.graphics.getWidth()/2,love.graphics.getHeight())
	-- love.graphics.line(0,love.graphics.getHeight()/2,love.graphics.getWidth(),love.graphics.getHeight()/2)
end

function love.keypressed(key,unicode)
	game.keypressed(key,unicode)
	
	if key == " " or key == "return" then
		game.text.advanceText()
	end
end

function love.keyreleased(key)
	game.keyreleased(key)
end